<?php
// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Report competency mojitoring event handler definition.
 *
 * @package report_lpmonitoring
 * @category event
 * @author     Serge Gauthier <serge.gauthier.2@umontreal.ca>
 * @copyright  2016 Université de Montréal
 * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

// List of observers.
$observers = array(
    array(
        'eventname'   => '\core\event\competency_framework_updated',
        'callback'    => '\report_lpmonitoring\event\observer::framework_updated',
    ),
    array(
        'eventname'   => '\core\event\competency_framework_deleted',
        'callback'    => '\report_lpmonitoring\event\observer::framework_deleted',
    ),
    array(
        'eventname'   => '\core\event\competency_updated',
        'callback'    => '\report_lpmonitoring\event\observer::competency_updated',
    ),
);
